
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <string.h>

using namespace std;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

const int MAX_STRLEN = 256;

class StringClass
{
public:

  StringClass() {  capacity = MAX_STRLEN; a = new char[capacity]; length = 0; }
  StringClass(const char *s);
  StringClass & operator=(const StringClass &);
  void print();

  char *a;        // dynamic array for string chars
  int capacity;   // max size of array
  int length;     // actual number of chars used

};

//----------------------------------------------------------------------------

// constructor which takes string literal

StringClass::StringClass(const char *s)
{
 capacity = MAX_STRLEN; 
 a = new char[capacity]; 
 length = strlen(s); 

 for (int i = 0; i < length; i++)
   a[i] = s[i];
}

//----------------------------------------------------------------------------

void StringClass::print()
{
  for (int i = 0; i < length; i++)
    cout << a[i];
  cout << endl;
}

//----------------------------------------------------------------------------

// original version 
/*
StringClass & StringClass::operator=(const StringClass &rtSide)
{
  capacity = rtSide.capacity;
  length = rtSide.length;
  delete [] a;  

  a = new char[capacity];
  for (int i = 0; i < length; i++)
    a[i] = rtSide.a[i];

  return *this;
}
*/
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------

int main()
{
  StringClass s("boolaboola");
  StringClass t("wahoo");

  s.print();
  t.print();

  s = s;   // = s?

  s.print();
  t.print();

  return 1;
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------














// version 2

StringClass & StringClass::operator=(const StringClass &rtSide)
{
  if (this != &rtSide) {

    capacity = rtSide.capacity;
    length = rtSide.length;
    delete [] a;  

    a = new char[capacity];
    for (int i = 0; i < length; i++)
      a[i] = rtSide.a[i];
  }

  return *this;
}

//----------------------------------------------------------------------------



